import { Plugin } from 'rollup';
export { Plugin as RollupPlugin } from 'rollup';
import { Compiler } from 'webpack';
export { Compiler as WebpackCompiler } from 'webpack';
import { Plugin as Plugin$1 } from 'vite';
export { Plugin as VitePlugin } from 'vite';
import VirtualModulesPlugin from 'webpack-virtual-modules';

declare type Thenable<T> = T | Promise<T>;
interface UnpluginOptions {
    name: string;
    enforce?: 'post' | 'pre' | undefined;
    transformInclude?: (id: string) => boolean;
    transform?: (code: string, id: string) => Thenable<string | {
        code: string;
        map: any;
    } | null | undefined>;
    load?: (id?: string) => Thenable<string | null | undefined>;
    resolveId?: (id?: string) => Thenable<string | null | undefined>;
    rollup?: Partial<Plugin>;
    webpack?: (compiler: Compiler) => void;
    vite?: Partial<Plugin$1>;
    __vfs?: VirtualModulesPlugin;
}
declare type UnpluginFactory<UserOptions> = (options?: UserOptions) => UnpluginOptions;
interface UnpluginInstance<UserOptions> {
    rollup: (options?: UserOptions) => Plugin;
    webpack: (options?: UserOptions) => any;
    vite: (options?: UserOptions) => Plugin$1;
    raw: UnpluginFactory<UserOptions>;
}
declare module 'webpack' {
    interface Compiler {
        $unpluginContext: Record<string, UnpluginOptions>;
    }
}

declare function createUnplugin<UserOptions = {}>(factory: UnpluginFactory<UserOptions>): UnpluginInstance<UserOptions>;

export { Thenable, UnpluginFactory, UnpluginInstance, UnpluginOptions, createUnplugin };
